//
//  MINTLMigemodoki.swift
//  TextEditDoc
//
//  Created by narita on 2019/09/06.
//  Copyright © 2019 narita. All rights reserved.
//

import Cocoa

class MINTLMigemodoki: NSObject
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    override init()
    {
        super.init()
        
        dictionary = MINTLMigemodokiDictionary()
    }
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods
    
    // MARK: - action methods
    
    @objc func regularExpression(inputString: NSString?) -> NSRegularExpression?
    {
        let theSet = NSMutableSet()

        if inputString != nil
        {
            theSet.add(inputString!)
        }

        // ローマ字入力と仮定する
        if let theHIRAGANAString = inputString?.stringLatinToHiragana()
        {
            theSet.add(theHIRAGANAString)
            theSet.addObjects(from: self.dictionary?.titles(for: theHIRAGANAString) as! [Any])
        }
        
        if let theZENKAKUString  = inputString?.stringToFullwidth()
        {
            theSet.add(theZENKAKUString)
        }
        
        if let theKATAKANAString = inputString?.stringLatinToKatakana()
        {
            theSet.add(theKATAKANAString)
            
            if let theHanKanaString = theKATAKANAString.stringToHalfwidth()
            {
                theSet.add(theHanKanaString)
            }
        }

        // ひらがな入力と仮定する
        if let theInputString = inputString
        {
            theSet.addObjects(from: self.dictionary?.titles(for: theInputString) as! [Any])
        }
        
        if let theKATAKANAString2 = inputString?.stringHiraganaToKatakana() // カタカナ
        {
            theSet.add(theKATAKANAString2)
            
            // 半角カタカナ
            if let theHanKanaString2 = theKATAKANAString2.stringToHalfwidth()
            {
                theSet.add(theHanKanaString2)
            }
        }
        
        if let theLatinString = inputString?.stringHiraganaToLatin() ?? nil // ローマ字
        {
            theSet.add(theLatinString)
        }
        
        
        // 曖昧なローマ字かな変換を使った辞書引きを使う
        if let theInputString = inputString as String?
        {
            let r2h = MINTLIncrimentalRomajiToHiragana.shared

            let theStrings = r2h.transformToHiraganaStrings(input: theInputString)
            
            for i in theStrings
            {
                // ひらがな
                theSet.add( i as NSString)
                
                if let katakana = i.stringHiraganaToKatakana() // カタカナ
                {
                    theSet.add(katakana)
                    
                    // 半角カタカナ
                    if let hankatakana = katakana.stringToHalfwidth()
                    {
                        theSet.add(hankatakana)
                    }
                }
                
                theSet.addObjects(from: self.dictionary?.titles(for: i as NSString) as! [Any])
            }
        }
        
        // NSRegularExpression.escapedPattern(for: string)を使ってエスケープした上でor結合
        let theRepString = (theSet.allObjects.map({ NSRegularExpression.escapedPattern(for:($0 as! String)) }) as NSArray).componentsJoined(by: "|")
        
        if let theResult = try? NSRegularExpression(pattern: theRepString, options: [.caseInsensitive])
        {
            return theResult
        }
        
        return nil
    }
    
    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    @objc var dictionary: MINTLMigemodokiDictionary? = nil

    // MARK: - Utility methods
    
}
